Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.

From: "Ali Sajassi (sajassi)" <[email-masked]>
Date: Tue, 16 Oct 2018 17:29:38 +0000

Yes, just the encoding of label value needs to be clear. 

Cheers,
Ali

On 10/15/18, 6:24 PM, "BESS on behalf of Jakob Heitz (jheitz)" <[email-masked] on behalf of [email-masked]> wrote:

    How about:
    The lower order 4 bits SHOULD be sent as 0 and ignored on receipt.
    
    Regards,
    Jakob.

    -----Original Message-----
    From: Zhuangshunwan <[email-masked]> 
    Sent: Monday, October 15, 2018 6:02 PM
    To: Jakob Heitz (jheitz) <[email-masked]>; BESS <[email-masked]>
    Subject: RE: Encoding a 20 bit label in a 24 bit field.
    
    It is good to make this explicit. This ambiguity has led to some unnecessary interworking problems.
    
    Should we also need to explicitly define the "bottom of stack" bit in the low-order bit of the 3-octet label field?
    
    Thanks,
    Shunwan
    
    -----Original Message-----
    From: BESS [mailto:[email-masked]] On Behalf Of Jakob Heitz (jheitz)
    Sent: Tuesday, October 16, 2018 4:21 AM
    To: BESS <[email-masked]>
    Subject: [bess] Encoding a 20 bit label in a 24 bit field.
    
    We have proposed the following erratum for RFC 7432.
    
    Opinions?
    
    Regards,
    Jakob.

    -----Original Message-----
    From: RFC Errata System <[email-masked]>
    Sent: Friday, October 12, 2018 12:37 PM
    To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
    Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
    Subject: [Technical Errata Reported] RFC7432 (5523)
    
    The following errata report has been submitted for RFC7432, "BGP MPLS-Based Ethernet VPN".
    
    --------------------------------------
    You may review the report below and at:
    http://www.rfc-editor.org/errata/eid5523
    
    --------------------------------------
    Type: Technical
    Reported by: Krishnamoorthy Arumugham <[email-masked]>
    
    Section: 7
    
    Original Text
    -------------
    Clarifications to following sub-sections:
    Section 7.1
    Section 7.2
    Section 7.5

    Corrected Text
    --------------
    Section 7.1:
    Add below text to the section 7.1 regarding the encoding of MPLS label:
    
    "The value of the 20-bit MPLS label is encoded in the high-order 20 bits of the 3 bytes MPLS Label field."
    
    Section 7.2:
    Add below text to the section 7.2 regarding the encoding of both the MPLS label fields:
    
    "The value of the 20-bit MPLS label is encoded in the high-order 20 bits of the 3 bytes MPLS Label field for both MPLS Label1 and MPLS Label2."
    
    Section 7.5:
    Add below text to the section 7.5 regarding the encoding of ESI Label fields:
    
    "The value of the 20-bit MPLS label is encoded in the high-order 20 bits of the ESI Label field."

    Notes
    -----
    MPLS label is a 20-bit value and is stored in a 3 bytes field in a packet. The 20-bit MPLS label value is generally stored in higher order 20 bits of the 3 byte label field. The exact encoding to be followed for storing MPLS label values are not explicitly mentioned in the RFC 7432 under section 7.1, 7.2 and 7.5 for different types of EVPN routes. This lead to ambiguity in different implementations. Hence a clarification is required.
    
    Instructions:
    -------------
    This erratum is currently posted as "Reported". If necessary, please
    use "Reply All" to discuss whether it should be verified or
    rejected. When a decision is reached, the verifying party  
    can log in to change the status and edit the report, if necessary. 
    
    --------------------------------------
    RFC7432 (draft-ietf-l2vpn-evpn-11)
    --------------------------------------
    Title               : BGP MPLS-Based Ethernet VPN
    Publication Date    : February 2015
    Author(s)           : A. Sajassi, Ed., R. Aggarwal, N. Bitar, A. Isaac, J. Uttaro, J. Drake, W. Henderickx
    Category            : PROPOSED STANDARD
    Source              : Layer 2 Virtual Private Networks
    Area                : Routing
    Stream              : IETF
    Verifying Party     : IESG
    
    _______________________________________________
    BESS mailing list
    [email-masked]
    https://www.ietf.org/mailman/listinfo/bess
    
    _______________________________________________
    BESS mailing list
    [email-masked]
    https://www.ietf.org/mailman/listinfo/bess

---

From: <[email-masked]>
Date: Mon, 22 Oct 2018 13:47:32 +0000

Hi,

Does anyone disagree with the additional Jakob's statement proposal ?
" The lower order 4 bits SHOULD be sent as 0 and ignored on receipt."

As an example, in MVPN for PMSI tunnel attribute, we have the following statement which does not tell anything about the lower order bits:
" If the MPLS Label field is non-zero, then it contains an MPLS label
   encoded as 3 octets, where the high-order 20 bits contain the label
   value.  Absence of an MPLS Label is indicated by setting the MPLS
   Label field to zero."

Brgds,

-----Original Message-----
From: BESS [mailto:[email-masked]] On Behalf Of Ali Sajassi (sajassi)
Sent: Tuesday, October 16, 2018 19:30
To: Jakob Heitz (jheitz); Zhuangshunwan; BESS
Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.

Cheers,
Ali

    How about:
    
    Regards,
    Jakob.

    -----Original Message-----
    From: Zhuangshunwan <[email-masked]> 
    Sent: Monday, October 15, 2018 6:02 PM
    To: Jakob Heitz (jheitz) <[email-masked]>; BESS <[email-masked]>
    Subject: RE: Encoding a 20 bit label in a 24 bit field.

    
    Thanks,
    Shunwan
    
    -----Original Message-----
    From: BESS [mailto:[email-masked]] On Behalf Of Jakob Heitz (jheitz)
    Sent: Tuesday, October 16, 2018 4:21 AM
    To: BESS <[email-masked]>
    Subject: [bess] Encoding a 20 bit label in a 24 bit field.

    Opinions?
    
    Regards,
    Jakob.

    -----Original Message-----
    From: RFC Errata System <[email-masked]>
    Sent: Friday, October 12, 2018 12:37 PM
    To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
    Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
    Subject: [Technical Errata Reported] RFC7432 (5523)

    
    
    Section: 7
    
    Original Text
    -------------

    Corrected Text
    --------------
    Section 7.1:

    Section 7.2:

    Section 7.5:

    Notes
    -----
    
    Instructions:
    -------------

    

_________________________________________________________________________________________________________________________

Ce message et ses pieces jointes peuvent contenir des informations confidentielles ou privilegiees et ne doivent donc
pas etre diffuses, exploites ou copies sans autorisation. Si vous avez recu ce message par erreur, veuillez le signaler
a l'expediteur et le detruire ainsi que les pieces jointes. Les messages electroniques etant susceptibles d'alteration,
Orange decline toute responsabilite si ce message a ete altere, deforme ou falsifie. Merci.

This message and its attachments may contain confidential or privileged information that may be protected by law;
they should not be distributed, used or copied without authorisation.
If you have received this email in error, please notify the sender and delete this message and its attachments.
As emails may be altered, Orange is not liable for messages that have been modified, changed or falsified.
Thank you.

---

From: "Acee Lindem (acee)" <[email-masked]>
Date: Mon, 22 Oct 2018 14:57:57 +0000

Hi Stephane, 
No objection - I think the question on whether BOS should be encoded in those bits confirms that this should be specified. 
Thanks,
Acee

On 10/22/18, 9:47 AM, "BESS on behalf of [email-masked]" <[email-masked] on behalf of [email-masked]> wrote:

    Hi,

    Brgds,

    -----Original Message-----
    From: BESS [mailto:[email-masked]] On Behalf Of Ali Sajassi (sajassi)
    Sent: Tuesday, October 16, 2018 19:30
    To: Jakob Heitz (jheitz); Zhuangshunwan; BESS
    Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.

    Cheers,
    Ali

    
        How about:
        
        Regards,
        Jakob.

        -----Original Message-----
        From: Zhuangshunwan <[email-masked]> 
        Sent: Monday, October 15, 2018 6:02 PM
        To: Jakob Heitz (jheitz) <[email-masked]>; BESS <[email-masked]>
        Subject: RE: Encoding a 20 bit label in a 24 bit field.

        
        Thanks,
        Shunwan
        
        -----Original Message-----
        From: BESS [mailto:[email-masked]] On Behalf Of Jakob Heitz (jheitz)
        Sent: Tuesday, October 16, 2018 4:21 AM
        To: BESS <[email-masked]>
        Subject: [bess] Encoding a 20 bit label in a 24 bit field.

        Opinions?
        
        Regards,
        Jakob.

        -----Original Message-----
        From: RFC Errata System <[email-masked]>
        Sent: Friday, October 12, 2018 12:37 PM
        To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
        Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
        Subject: [Technical Errata Reported] RFC7432 (5523)

        
        
        Section: 7
        
        Original Text
        -------------

        Corrected Text
        --------------
        Section 7.1:

        Section 7.2:

        Section 7.5:

        Notes
        -----
        
        Instructions:
        -------------

---

From: "Jakob Heitz (jheitz)" <[email-masked]>
Date: Mon, 22 Oct 2018 17:42:42 +0000

I think it's cleaner to make the statement, but I don't think it matters to omit the statement.
Even if there was a BOS, it would be ignored.
The extcomm carries a single label. Exactly one. It's not a stack.
When the label eventually gets imposed onto a stack, that stack will have its own bottom, regardless of any BOS bit on our precious label.

Regards,
Jakob.

-----Original Message-----
From: Acee Lindem (acee) 
Sent: Monday, October 22, 2018 7:58 AM
To: [email-masked]; Ali Sajassi (sajassi) <[email-masked]>; Jakob Heitz (jheitz) <[email-masked]>; Zhuangshunwan <[email-masked]>; BESS <[email-masked]>
Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.

Hi Stephane, 

    Hi,

    Brgds,

    -----Original Message-----
    From: BESS [mailto:[email-masked]] On Behalf Of Ali Sajassi (sajassi)
    Sent: Tuesday, October 16, 2018 19:30
    To: Jakob Heitz (jheitz); Zhuangshunwan; BESS
    Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.

    Cheers,
    Ali

    
        How about:
        
        Regards,
        Jakob.

        -----Original Message-----
        From: Zhuangshunwan <[email-masked]> 
        Sent: Monday, October 15, 2018 6:02 PM
        To: Jakob Heitz (jheitz) <[email-masked]>; BESS <[email-masked]>
        Subject: RE: Encoding a 20 bit label in a 24 bit field.

        
        Thanks,
        Shunwan
        
        -----Original Message-----
        From: BESS [mailto:[email-masked]] On Behalf Of Jakob Heitz (jheitz)
        Sent: Tuesday, October 16, 2018 4:21 AM
        To: BESS <[email-masked]>
        Subject: [bess] Encoding a 20 bit label in a 24 bit field.

        Opinions?
        
        Regards,
        Jakob.

        -----Original Message-----
        From: RFC Errata System <[email-masked]>
        Sent: Friday, October 12, 2018 12:37 PM
        To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
        Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
        Subject: [Technical Errata Reported] RFC7432 (5523)

        
        
        Section: 7
        
        Original Text
        -------------

        Corrected Text
        --------------
        Section 7.1:

        Section 7.2:

        Section 7.5:

        Notes
        -----
        
        Instructions:
        -------------

---

From: Greg Mirsky <[email-masked]>
Date: Mon, 22 Oct 2018 15:07:39 -0700

Hi Stephane,
should note that "setting the MPLS Label field to zero" may be also
interpreted as a valid label, IPv4 Explicit Null Label.

Regards,
Greg

On Mon, Oct 22, 2018 at 6:47 AM <[email-masked]> wrote:

> As an example, in MVPN for PMSI tunnel attribute, we have the following
> statement which does not tell anything about the lower order bits:
> On 10/15/18, 6:24 PM, "BESS on behalf of Jakob Heitz (jheitz)" <
> [email-masked] on behalf of [email-masked]> wrote:
>
>     How about:
>     Should we also need to explicitly define the "bottom of stack" bit in
> the low-order bit of the 3-octet label field?
>
>     Thanks,
>     Shunwan
>
>     To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; Giles Heron (giheron)
> <[email-masked]>; [email-masked]
>     Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>;
> [email-masked]; [email-masked]
>     "The value of the 20-bit MPLS label is encoded in the high-order 20
> bits of the 3 bytes MPLS Label field for both MPLS Label1 and MPLS Label2."
>
>     Section 7.5:
>     MPLS label is a 20-bit value and is stored in a 3 bytes field in a
> packet. The 20-bit MPLS label value is generally stored in higher order 20
> bits of the 3 byte label field. The exact encoding to be followed for
> storing MPLS label values are not explicitly mentioned in the RFC 7432
> under section 7.1, 7.2 and 7.5 for different types of EVPN routes. This
> lead to ambiguity in different implementations. Hence a clarification is
> required.
>
>     Instructions:
>     -------------
>     Author(s)           : A. Sajassi, Ed., R. Aggarwal, N. Bitar, A.
> Isaac, J. Uttaro, J. Drake, W. Henderickx
> Ce message et ses pieces jointes peuvent contenir des informations
> confidentielles ou privilegiees et ne doivent donc
> pas etre diffuses, exploites ou copies sans autorisation. Si vous avez
> recu ce message par erreur, veuillez le signaler
> a l'expediteur et le detruire ainsi que les pieces jointes. Les messages
> electroniques etant susceptibles d'alteration,
> This message and its attachments may contain confidential or privileged
> information that may be protected by law;

---

From: "Ali Sajassi (sajassi)" <[email-masked]>
Date: Mon, 22 Oct 2018 22:32:37 +0000

Hi Greg,
The text that Stephane mentioned is from “MVPN for PMSI tunnel attribute” and not from proposed text for RFC 7432 errata.

Hi Stephane,
I think the provided text in Errata below is sufficient and we don’t need to say “The lower order 4 bits SHOULD be sent as 0 and ignored on receipt." In case of penultimate hop pop and need to use EXP bits for QoS.

Cheers,
Ali

From: Greg Mirsky <[email-masked]>
Date: Monday, October 22, 2018 at 3:07 PM
To: Stephane Litkowski <[email-masked]>
Cc: Cisco Employee <[email-masked]>, "Jakob Heitz (jheitz)" <[email-masked]>, "[email-masked]" <[email-masked]>, BESS <[email-masked]>
Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.

Hi Stephane,
should note that "setting the MPLS Label field to zero" may be also interpreted as a valid label, IPv4 Explicit Null Label.

Regards,
Greg

On Mon, Oct 22, 2018 at 6:47 AM <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

Brgds,

-----Original Message-----
From: BESS [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Ali Sajassi (sajassi)
Sent: Tuesday, October 16, 2018 19:30
To: Jakob Heitz (jheitz); Zhuangshunwan; BESS
Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.

Cheers,
Ali

On 10/15/18, 6:24 PM, "BESS on behalf of Jakob Heitz (jheitz)" <[email-masked]<mailto:[email-masked]> on behalf of [email-masked]<mailto:[email-masked]>> wrote:

    How about:

    Regards,
    Jakob.

    -----Original Message-----
    From: Zhuangshunwan <[email-masked]<mailto:[email-masked]>>
    Sent: Monday, October 15, 2018 6:02 PM
    To: Jakob Heitz (jheitz) <[email-masked]<mailto:[email-masked]>>; BESS <[email-masked]<mailto:[email-masked]>>
    Subject: RE: Encoding a 20 bit label in a 24 bit field.

    Thanks,
    Shunwan

    -----Original Message-----
    From: BESS [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Jakob Heitz (jheitz)
    Sent: Tuesday, October 16, 2018 4:21 AM
    To: BESS <[email-masked]<mailto:[email-masked]>>
    Subject: [bess] Encoding a 20 bit label in a 24 bit field.

    Opinions?

    Regards,
    Jakob.

    -----Original Message-----
    From: RFC Errata System <[email-masked]<mailto:[email-masked]>>
    Sent: Friday, October 12, 2018 12:37 PM
    To: Ali Sajassi (sajassi) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Giles Heron (giheron) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>
    Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
    Subject: [Technical Errata Reported] RFC7432 (5523)

    --------------------------------------
    Type: Technical
    Reported by: Krishnamoorthy Arumugham <[email-masked]<mailto:[email-masked]>>

    Section: 7

    Original Text
    -------------

    Corrected Text
    --------------
    Section 7.1:

    Section 7.2:

    Section 7.5:

    Notes
    -----

    Instructions:
    -------------

    _______________________________________________
    BESS mailing list
    [email-masked]<mailto:[email-masked]>
    https://www.ietf.org/mailman/listinfo/bess

    _______________________________________________
    BESS mailing list
    [email-masked]<mailto:[email-masked]>
    https://www.ietf.org/mailman/listinfo/bess

_______________________________________________
BESS mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/bess

_______________________________________________
BESS mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/bess